Index: gtk/apport-gtk
===================================================================
--- gtk/apport-gtk.orig
+++ gtk/apport-gtk
@@ -57,6 +57,10 @@ class GTKUserInterface(apport.ui.UserInt
         self.str_radio_complete = self.w('radiobutton_complete').get_label()
         self.str_radio_reduced = self.w('radiobutton_reduced').get_label()
 
+        # enable e-mail input if allowed
+        if self.crashdb.options.get('mail_input'):
+            self.w('mail_vbox').show()
+
     #
     # ui_* implementation of abstract UserInterface classes
     #
@@ -166,6 +170,11 @@ class GTKUserInterface(apport.ui.UserInt
         while gtk.events_pending():
             gtk.main_iteration(False)
 
+        if self.crashdb.options.get('mail_input') and self.w('mail_check').get_active():
+            self.report['ResponseEmail'] = self.w('mail_entry').get_text()
+
+        self.report['UserActivity'] = self.w('description_entry').get_text()
+
         if response == gtk.RESPONSE_YES:
             if self.w('radiobutton_complete').get_active():
                 return 'full'
@@ -280,6 +289,17 @@ class GTKUserInterface(apport.ui.UserInt
         sys.exit(0)
         return True
 
+    def on_mail_check_toggled(self, widget):
+        self.w('mail_entry').set_sensitive(widget.get_active())
+        if widget.get_active():
+            self.w('mail_entry').set_text("")
+        else:
+            self.w('mail_entry').set_text("your e-mail address")
+
+        while gtk.events_pending():
+            gtk.main_iteration(False)
+        return True
+
     def on_expander_details_activate(self, widget):
         # signal is sent before actually expanding/collapsing, thus this
         # requires negation
Index: gtk/apport-gtk.glade
===================================================================
--- gtk/apport-gtk.glade.orig
+++ gtk/apport-gtk.glade
@@ -376,7 +376,7 @@
 
 <widget class="GtkWindow" id="window_information_collection">
   <property name="border_width">12</property>
-  <property name="title">Apport</property>
+  <property name="title">Problem Report</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
   <property name="window_position">GTK_WIN_POS_CENTER_ALWAYS</property>
   <property name="modal">False</property>
@@ -509,7 +509,7 @@
 
 <widget class="GtkDialog" id="dialog_bugreport">
   <property name="border_width">6</property>
-  <property name="title">Apport</property>
+  <property name="title">Problem Report</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
   <property name="window_position">GTK_WIN_POS_NONE</property>
   <property name="modal">True</property>
@@ -593,9 +593,9 @@
 	  <child>
 	    <widget class="GtkLabel" id="label_bug_instructions">
 	      <property name="visible">True</property>
-	      <property name="label" translatable="yes">&lt;big&gt;&lt;b&gt;Send problem report to the developers?&lt;/b&gt;&lt;/big&gt;
+	      <property name="label" translatable="yes">&lt;big&gt;&lt;b&gt;Share Crash Report with Development&lt;/b&gt;&lt;/big&gt;
 
-After the problem report has been sent, please fill out the form in the automatically opened web browser.</property>
+To help us diagnose and fix the problem in future releases, you can send us a crash report</property>
 	      <property name="use_underline">False</property>
 	      <property name="use_markup">True</property>
 	      <property name="justify">GTK_JUSTIFY_LEFT</property>
@@ -728,6 +728,113 @@ After the problem report has been sent,
 		</packing>
 	      </child>
 	    </widget>
+	    <packing>
+	      <property name="padding">0</property>
+	      <property name="expand">True</property>
+	      <property name="fill">True</property>
+	    </packing>
+	  </child>
+
+	  <child>
+	    <widget class="GtkVBox" id="mail_vbox">
+	      <property name="homogeneous">False</property>
+	      <property name="spacing">0</property>
+
+	      <child>
+		<widget class="GtkHSeparator" id="hseparator1">
+		  <property name="visible">True</property>
+		</widget>
+		<packing>
+		  <property name="padding">0</property>
+		  <property name="expand">True</property>
+		  <property name="fill">True</property>
+		</packing>
+	      </child>
+
+	      <child>
+		<widget class="GtkLabel" id="label22">
+		  <property name="visible">True</property>
+		  <property name="label" translatable="yes">What activity crashed the program?</property>
+		  <property name="use_underline">False</property>
+		  <property name="use_markup">False</property>
+		  <property name="justify">GTK_JUSTIFY_LEFT</property>
+		  <property name="wrap">False</property>
+		  <property name="selectable">False</property>
+		  <property name="xalign">0</property>
+		  <property name="yalign">0.5</property>
+		  <property name="xpad">0</property>
+		  <property name="ypad">0</property>
+		  <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+		  <property name="width_chars">-1</property>
+		  <property name="single_line_mode">False</property>
+		  <property name="angle">0</property>
+		</widget>
+		<packing>
+		  <property name="padding">5</property>
+		  <property name="expand">False</property>
+		  <property name="fill">False</property>
+		</packing>
+	      </child>
+
+	      <child>
+		<widget class="GtkEntry" id="description_entry">
+		  <property name="visible">True</property>
+		  <property name="can_focus">True</property>
+		  <property name="editable">True</property>
+		  <property name="visibility">True</property>
+		  <property name="max_length">0</property>
+		  <property name="text" translatable="yes"></property>
+		  <property name="has_frame">True</property>
+		  <property name="invisible_char">●</property>
+		  <property name="activates_default">False</property>
+		</widget>
+		<packing>
+		  <property name="padding">0</property>
+		  <property name="expand">False</property>
+		  <property name="fill">False</property>
+		</packing>
+	      </child>
+
+	      <child>
+		<widget class="GtkCheckButton" id="mail_check">
+		  <property name="visible">True</property>
+		  <property name="can_focus">True</property>
+		  <property name="label" translatable="yes">e-mail me if more information becomes available</property>
+		  <property name="use_underline">True</property>
+		  <property name="relief">GTK_RELIEF_NORMAL</property>
+		  <property name="focus_on_click">True</property>
+		  <property name="active">False</property>
+		  <property name="inconsistent">False</property>
+		  <property name="draw_indicator">True</property>
+		  <signal name="toggled" handler="on_mail_check_toggled" last_modification_time="Tue, 16 Feb 2010 11:51:53 GMT"/>
+		</widget>
+		<packing>
+		  <property name="padding">0</property>
+		  <property name="expand">False</property>
+		  <property name="fill">False</property>
+		</packing>
+	      </child>
+
+	      <child>
+		<widget class="GtkEntry" id="mail_entry">
+		  <property name="visible">True</property>
+		  <property name="sensitive">False</property>
+		  <property name="can_focus">True</property>
+		  <property name="editable">True</property>
+		  <property name="visibility">True</property>
+		  <property name="max_length">0</property>
+		  <property name="text" translatable="yes">your e-mail address</property>
+		  <property name="has_frame">True</property>
+		  <property name="invisible_char">●</property>
+		  <property name="activates_default">False</property>
+		</widget>
+		<packing>
+		  <property name="padding">0</property>
+		  <property name="expand">False</property>
+		  <property name="fill">False</property>
+		</packing>
+	      </child>
+	    </widget>
 	    <packing>
 	      <property name="padding">0</property>
 	      <property name="expand">True</property>
